def fetch_latest(repo, test=False):
    if not test:
        o = repo.remotes.origin
        o.pull('master')


def initialize_project(repo, project, test=False):
    if not test:
        repo.git.add('--all')
        repo.index.commit('Initialize %s' % project)

        o = repo.remotes.origin
        o.push('master')


def record_create_attempt(repo, hash, project, test=False):
    if not test:
        repo.git.branch(hash)
        repo.git.checkout(hash)
        repo.git.add('--all')
        repo.index.commit(
            'Creating current project state for %s' % project
        )


def record_successful_create(repo, hash, feature, project, test=False):
    if not test:
        # On success, merge and commit to master
        repo.git.checkout('master')
        repo.git.merge(hash, '-X', 'theirs', '--squash')
        repo.git.branch('-D', hash)
        repo.index.commit(
            'Successful creation :: %s :: %s' % (feature, project)
        )

        # Push Changes
        o = repo.remotes.origin
        o.push('master')


def record_successful_update(repo, hash, feature, project, test=False):
    if not test:
        # On success, merge and commit to master
        repo.git.checkout('master')
        repo.git.merge(hash, '-X', 'theirs', '--squash')
        repo.git.branch('-D', hash)
        repo.index.commit(
            'Successful update :: %s :: %s' % (feature, project)
        )

        # Push Changes
        o = repo.remotes.origin
        o.push('master')


def rollback(repo, hash, test=False):
    if not test:
        self.repo.git.checkout('master')
        self.repo.git.branch('-D', hash)
