import os

import boto3
import git
from prettytable import PrettyTable

from repo import initialize_project, fetch_latest


def output_success_results(result, test=False):
    if not test:
        print("\nThe stack '%s' is updated successfully!\n" % result.get('StackName'))

        outputs = result.get('Outputs')
        if outputs:
            table = PrettyTable(["Key", "Value"], align='l')
            for output in outputs:
                table.add_row([output.get('OutputKey'), output.get('OutputValue')])

            table.align = 'l'
            print(table)


def write_state(project_dir, state, test=False):
    if not test:
        with open(os.path.join(project_dir, 'state.json'), 'w') as f:
            f.write(state.to_json())

def write_aws_state(project_dir, state, test=False):
    if not test:
        with open(os.path.join(project_dir, 'aws.state.json'), 'w') as f:
            f.write(state.to_json())

def compare_state(project_dir, test=False):
    if not test:
        with open(os.path.join(project_dir, 'state.json'), 'r') as f:
            state = json.load(f)

        with open(os.path.join(project_dir, 'aws.state.json'), 'r') as f:
            aws_state = json.load(f)


def setup_project(repo, project, repo_dir, project_dir, test=False):
    if not test:
        if os.path.exists(repo_dir):
            repo = git.Repo(repo_dir)
            fetch_latest(repo)

            if not os.path.exists(project_dir):
                os.makedirs(project_dir)
                f = open(os.path.join(project_dir, '.gitkeep'), 'w')
                f.close()

                initialize_project(repo, project)
        else:
            os.makedirs(repo_dir)
            repo = git.Repo.clone_from(repo, repo_dir)

            if not os.path.exists(project_dir):
                os.makedirs(project_dir)
                f = open(os.path.join(project_dir, '.gitkeep'), 'w')
                f.close()

                initialize_project(repo, project)

        return repo
